import com.stencyl.models.Actor;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.Engine;


class PositioningUtils
{
	/*// To change in xml
	public static function getScale(axis:String, actor:Actor)
	{
	
		switch axis
		{
			case "h": 		return actor.realScaleY * 100;
			default:
							return actor.realScaleX * 100;
		}
	}*/
	

	// To correct
	public static function scaledCoord(axis:String, actor:Actor)
	{
		switch axis
		{
			case "xs":		return ScaleUtils.offset(actor.getScreenX(), "xr", actor);
			case "ys": 		return ScaleUtils.offset(actor.getScreenY(), "yr", actor);
			case "y": 		return ScaleUtils.offset(actor.getY(), "yr", actor);
			default:
							return ScaleUtils.offset(actor.getX(), "xr", actor);
		}
	}
	
	// To correct
	public static function offset(coord:Float, axis:String, actor:Actor)
	{
		switch axis
		{
			case "xr":		return ((	actor.getWidth()	- actor.getWidth()	% 2) * (actor.realScaleX - 1)) / -2 + coord;
			case "yr": 		return ((	actor.getHeight()	- actor.getHeight() % 2) * (actor.realScaleY - 1)) / -2 + coord;
			case "ya": 		return (((	actor.getHeight()	- actor.getHeight() % 2) * (actor.realScaleY - 1)) / -2 + coord) * -1;
			default:
							return (((	actor.getWidth()	- actor.getWidth()	% 2) * (actor.realScaleX - 1)) / -2 + coord) * -1;
		}
	}
	
	/*
	 *	Change scale of actor in percentage
	 */
	public static function scale(axis:String, percent:Float, actor:Actor)
	{
		var factor = percent / 100;
		
		switch axis
		{
			case "width":	actor.realScaleX = factor;
			case "height":	actor.realScaleY = factor;
			default:
							actor.realScaleX = factor;
							actor.realScaleY = factor;
		}
	}
	
	/*
	*	Change scale actor in pixel
	*/
	public static function setScale(newSize:Float, actor:Actor, axis:String, ?keepRatio:Bool)
	{

		switch axis
		{
			case "width":	actor.realScaleX = newSize / actor.getWidth();
							if 	(keepRatio)	 {actor.realScaleY = actor.realScaleX * (actor.getHeight()/actor.getWidth());}	
			case "height":	actor.realScaleY = newSize / actor.getHeight();	
							if (keepRatio) {actor.realScaleX = actor.realScaleY * (actor.getWidth()/actor.getHeight());}	
							
			default:	/*
							actor.realScaleX = newSize / actor.getWidth();
							actor.realScaleY = newSize / actor.getHeight();
							*/
		}
	}


	//XML ??
	public static function scaledSize(axis:String, actor:Actor)
	{
		switch axis
		{
			case "halfwidth":	return actor.getWidth()		* actor.realScaleX / 2;
			case "halfheight":	return actor.getHeight()	* actor.realScaleY / 2;
			case "height":		return actor.getHeight()	* actor.realScaleY;
			default:
								return actor.getWidth()		* actor.realScaleX;
		}
	}
	
	/*
	// XML ?
	public static function isScaled(actor:Actor)
	{
		return actor.realScaleX != 1 || actor.realScaleY != 1;
	}
	*/


	/*
	*	Set real size, useful when image instance attached with it
	*/
	public static function setRealSize(height: Float, width:Float, actor:Actor)
	{
		// saving data before them being modified
		var oldX:Float = actor.getX();
		var oldY:Float = actor.getY();
		var newOriginX:Float = actor.currOrigin.x * width / actor.width;
		var newOriginY:Float = actor.currOrigin.y * height / actor.height;

		actor.realScaleX = 1;
		actor.realScaleY = 1;
		actor.width = width;
		actor.height = height;
		actor.cacheWidth = width /Engine.SCALE;
		actor.cacheHeight = height/Engine.SCALE;
		actor.realX = actor.realX + width/2;		// Is it dependent on actor's origin ??????
		actor.realY = actor.realY + height/2;
		actor.drawX = actor.drawX + width/2;
		actor.drawY = actor.drawY + height/2;
		actor.currOrigin.x = newOriginX;
		actor.currOrigin.y = newOriginY;
		actor.setX(oldX);
		actor.setY(oldY);
	}


	/*
	*	Set height and width , Grow from specific point
	*/
	public static function setHeightAndWidth(height:Float, width:Float, horAlignment:String, verAlignment:String, actor:Actor)
	{
		// Bug with stencyl Engine : Changing origin points and growing don't grow the click size accordingly
		// So you have to change temporarily the origin point to the centre
		var oldOriginPointX:Int = Std.int(actor.currOrigin.x);
		var oldOriginPointY:Int = Std.int(actor.currOrigin.y);
		actor.setOriginPoint(Std.int(actor.getWidth()/2), Std.int(actor.getHeight()/2));

		// Setting coordinates to adapt to the grow from the centre
		if (verAlignment == "top")
		{
			actor.setX(actor.getX() + (width - actor.getWidth())/2);
		}
		else if (verAlignment == "bottom")
		{
			actor.setX(actor.getX() - (width - actor.getWidth())/2);
		}
		if (horAlignment == "left")
		{
			actor.setY(actor.getY() + (height - actor.getHeight())/2);
		}
		else if (horAlignment == "right")
		{
			actor.setY(actor.getY() - (height - actor.getHeight())/2);
		}

		// Then Grow
		setScale( width, actor,"width", false);
		setScale( height, actor,"height", false);

		// Set old defaults back
		actor.setOriginPoint(oldOriginPointX, oldOriginPointY); 
	}

	/*
	*	Grow actor to fit in Rectangle
	*/
	public static function fitActorInRectangle(maxHeight:Float, maxWidth:Float, verAlignment:String, horAlignment:String, actor:Actor, canGrow:Bool):Void
	{
		// Bug with stencyl Engine : Changing origin points and growing don't grow the click size accordingly
		// So you have to change temporarily the origin point to the centre
		var oldOriginPointX:Int = Std.int(actor.currOrigin.x);
		var oldOriginPointY:Int = Std.int(actor.currOrigin.y);
		actor.setOriginPoint(Std.int(actor.getWidth()/2), Std.int(actor.getHeight()/2));
		var oldHeight:Float = scaledSize("height", actor);
		var oldWidth:Float = scaledSize("width", actor);


		if(scaledSize("height", actor) > scaledSize("width", actor))
		{
			//scale("width", (maxHeight / scaledSize("height",actor)) * 100, actor);
			setScale(maxHeight, actor,"height", true);
		}
		else
		{
			//scale("height", ((maxWidth / scaledSize("width", actor)) * 100), actor);
			setScale(maxWidth, actor,"width", true);
		}


		if(horAlignment == "left")
		{
			actor.setX(actor.getX() + (scaledSize("width", actor) - oldWidth) / 2);
		}
		else if((horAlignment == "right"))
		{
			actor.setX(actor.getX() - (scaledSize("width", actor) - oldWidth) / 2);
		}
		if(verAlignment == "top")
		{
			actor.setY(actor.getY() + (scaledSize("height", actor) - oldHeight) / 2);
		}
		else if((verAlignment == "bottom"))
		{
			actor.setY(actor.getY() + (scaledSize("height", actor) - oldHeight) / 2);
		}


		// Set old defaults back
		actor.setOriginPoint(oldOriginPointX, oldOriginPointY);
	}

	
	/*
	 * Set width/height in pixel for image instance
	 */

	public static function setPixSizeForImgInst(axis:String, newSize:Float, keepRatio:Bool, imgInst:BitmapWrapper):Void
	{
		var width:Float = imgInst.width/Engine.SCALE;
		var height:Float = imgInst.height/Engine.SCALE;
		switch axis
		{
			case "width":	imgInst.scaleX = newSize / width;
							if 	(keepRatio)	 {imgInst.scaleY = imgInst.scaleX * (height/width);}	
			case "height":	imgInst.scaleY = newSize / height;	
							if (keepRatio) {imgInst.scaleX = imgInst.scaleY * (width/height);}	
							
			default:	/*
							actor.realScaleX = newSize / actor.getWidth();
							actor.realScaleY = newSize / actor.getHeight();
							*/
		}
	}


	/*
	 *	Get scaled Pixel height for image instance
	 */

	public static  function getPixHeightForImgInst(axis:String, imgInst:BitmapWrapper):Float
	{
		if (axis == "height")
		{
			return imgInst.scaleY*imgInst.height;
		}
		else
		{
			return imgInst.scaleX*imgInst.width;
		}
	}

	/*
	 *	Fit image instance into rectangle
	 */

	public static function fitImgInstInRectangle(maxHeight:Float, maxWidth:Float, verAlignment:String, horAlignment:String, imgInst:BitmapWrapper):Void
	{

		var oldHeight:Float = getPixHeightForImgInst("height", imgInst);
		var oldWidth:Float = getPixHeightForImgInst("height", imgInst);


		if(oldHeight > oldWidth)
		{
			setPixSizeForImgInst("height", maxHeight, true, imgInst);
		}
		else
		{
			setPixSizeForImgInst("width", maxWidth, true, imgInst);
		}

		/*
		if(horAlignment == "left")
		{
			actor.setX(actor.getX() + (scaledSize("width", actor) - oldWidth) / 2);
		}
		else if((horAlignment == "right"))
		{
			actor.setX(actor.getX() - (scaledSize("width", actor) - oldWidth) / 2);
		}
		if(verAlignment == "top")
		{
			actor.setY(actor.getY() + (scaledSize("height", actor) - oldHeight) / 2);
		}
		else if((verAlignment == "down"))
		{
			actor.setY(actor.getY() + (scaledSize("height", actor) - oldHeight) / 2);
		}
		*/

	}


	/*
	 *
	 */
	public static function setXActor(x:Float, scale:Bool, screenPos:Bool, actorPos:Bool, actor:Actor):Void
	{
		var newX:Float;
		var w:Float;
		if (screenPos) newX = Engine.screenWidth - x : newX = x;
		if (scale) w = scaledSize("width", actor) : w = actor.width;
		if (actorPos) newX =- w;
		// set scaleX
	}

	/*
	 *
	 */
	public static function setScaleCoord(axis:Bool, coord:Float):Void
	{

	}






	
}
